﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Microsoft.Expression.Controls;
using System.Collections.ObjectModel;

namespace SilverlightApplication1
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			// Required to initialize variables
			InitializeComponent();

			tabControl.ItemsSource = GenerateData();
		}

		public ObservableCollection<DataItem> GenerateData()
		{
			ObservableCollection<DataItem> result = new ObservableCollection<DataItem>();
			for (int i = 0; i < 3; i++)
			{
				result.Add(new DataItem()
				{
					Name = String.Format("Name {0}", i),
					Address = String.Format("Name {0}", i),
					DateOfBirth = DateTime.Today
				});
			}
			return result;
		}
	}
	public class PathRadTabItem : RadTabItem, IPathLayoutItem
	{
		public static readonly DependencyProperty GlobalIndexProperty = DependencyProperty.Register("GlobalIndex", typeof(int), typeof(PathRadTabItem), new PropertyMetadata(0));
		public static readonly DependencyProperty GlobalOffsetProperty = DependencyProperty.Register("GlobalOffset", typeof(double), typeof(PathRadTabItem), new PropertyMetadata(0.0));
		public static readonly DependencyProperty LayoutPathIndexProperty = DependencyProperty.Register("LayoutPathIndex", typeof(int), typeof(PathRadTabItem), new PropertyMetadata(0));
		public static readonly DependencyProperty LocalIndexProperty = DependencyProperty.Register("LocalIndex", typeof(int), typeof(PathRadTabItem), new PropertyMetadata(0));
		public static readonly DependencyProperty LocalOffsetProperty = DependencyProperty.Register("LocalOffset", typeof(double), typeof(PathRadTabItem), new PropertyMetadata(0.0));
		public static readonly DependencyProperty NormalAngleProperty = DependencyProperty.Register("NormalAngle", typeof(double), typeof(PathRadTabItem), new PropertyMetadata(0.0));
		public static readonly DependencyProperty OrientationAngleProperty = DependencyProperty.Register("OrientationAngle", typeof(double), typeof(PathRadTabItem), new PropertyMetadata(0.0));
		public event EventHandler<PathLayoutUpdatedEventArgs> PathLayoutUpdated;


		public PathRadTabItem()
		{
			DefaultStyleKey = typeof(PathRadTabItem);
		}

		public int GlobalIndex
		{
			get
			{
				return (int)GetValue(GlobalIndexProperty);
			}
			internal set
			{
				SetValue(GlobalIndexProperty, value);
			}
		}

		public double GlobalOffset
		{
			get
			{
				return (double)GetValue(GlobalOffsetProperty);
			}
			internal set
			{
				SetValue(GlobalOffsetProperty, value);
			}
		}

		public int LayoutPathIndex
		{
			get
			{
				return (int)GetValue(LayoutPathIndexProperty);
			}
			internal set
			{
				SetValue(LayoutPathIndexProperty, value);
			}
		}

		public int LocalIndex
		{
			get
			{
				return (int)GetValue(LocalIndexProperty);
			}
			internal set
			{
				SetValue(LocalIndexProperty, value);
			}
		}

		public double LocalOffset
		{
			get
			{
				return (double)GetValue(LocalOffsetProperty);
			}
			internal set
			{
				SetValue(LocalOffsetProperty, value);
			}
		}

		public double NormalAngle
		{
			get
			{
				return (double)GetValue(NormalAngleProperty);
			}
			internal set
			{
				SetValue(NormalAngleProperty, value);
			}
		}

		public double OrientationAngle
		{
			get
			{
				return (double)GetValue(OrientationAngleProperty);
			}
			internal set
			{
				SetValue(OrientationAngleProperty, value);
			}
		}



		public void Update(PathLayoutData data)
		{
			ChangedPathLayoutProperties none = ChangedPathLayoutProperties.None;
			if (this.LayoutPathIndex != data.LayoutPathIndex)
			{
				none |= ChangedPathLayoutProperties.LayoutPathIndex;
				this.LayoutPathIndex = data.LayoutPathIndex;
			}
			if (this.GlobalIndex != data.GlobalIndex)
			{
				none |= ChangedPathLayoutProperties.GlobalIndex;
				this.GlobalIndex = data.GlobalIndex;
			}
			if (this.LocalIndex != data.LocalIndex)
			{
				none |= ChangedPathLayoutProperties.LocalIndex;
				this.LocalIndex = data.LocalIndex;
			}
			if (this.GlobalOffset != data.GlobalOffset)
			{
				none |= ChangedPathLayoutProperties.GlobalOffset;
				this.GlobalOffset = data.GlobalOffset;
			}
			if (this.LocalOffset != data.LocalOffset)
			{
				none |= ChangedPathLayoutProperties.LocalOffset;
				this.LocalOffset = data.LocalOffset;
			}
			if (this.NormalAngle != data.NormalAngle)
			{
				none |= ChangedPathLayoutProperties.NormalAngle;
				this.NormalAngle = data.NormalAngle;
			}
			if (this.OrientationAngle != data.OrientationAngle)
			{
				none |= ChangedPathLayoutProperties.OrientationAngle;
				this.OrientationAngle = data.OrientationAngle;
			}
			this.OnPathLayoutUpdated(new PathLayoutUpdatedEventArgs(none));
		}

		void OnPathLayoutUpdated(PathLayoutUpdatedEventArgs pathLayoutArgs)
		{
			if (PathLayoutUpdated != null)
			{
				PathLayoutUpdated(this, pathLayoutArgs);
			}
		}
	}

	public class PathTabControl : RadTabControl
	{
		protected override DependencyObject GetContainerForItemOverride()
		{
			return new PathRadTabItem();
		}
	}
	public class DataItem
	{
		public string Name { get; set; }
		public string Address { get; set; }
		public DateTime DateOfBirth { get; set; }
	}
}